﻿// Fast Shape Layers creation by AEplug
// http://aeplug.ru/forum/viewtopic.php?t=637

PrintMessage("-------");
var StrokeCB, FillCB, NewGroupCB;
var script_version = "v1.0";

var DataArray = new Object();
var FileScript = File($.fileName);
var folder = Folder(FileScript.parent);
var folderIni = Folder(folder.fsName + "/Ini");
if (!folderIni.exists)
	folderIni.create();
var FileIni = new File(folderIni.toString() + "/" + "SimpleShape.ini");
var DataChanged = false;
if (!FileIni.exists){
	PrintMessage("Установка стандартных значений");
	SetData ("StrokeCB", "true");
	SetData ("FillCB", "true");
	SetData ("NewGroupCB", "false");
	}

function buildGUI(thisObj)
{
	var w = (thisObj instanceof Panel) ? thisObj : new Window("palette", "SimpleShape"+script_version);
	w.alignChildren = ['left', 'top'];
	w.margins = 6; //пустое расстояние от края окна
	w.spacing = 4; //пустое расстояние между элементами окна
	var goBttn = w.add("button", undefined, "Circle");
	goBttn.onClick = function()
	{
		Creation(1,"Circle");
	}
	var goBttn = w.add("button", undefined, "Square");
	goBttn.onClick = function()
	{
		Creation(2,"Square");
	}
	var goBttn = w.add("button", undefined, "Path");
	goBttn.onClick = function()
	{
		Creation(3,"Path");
	}
	StrokeCB = w.add("checkbox",undefined,"Stroke");
	StrokeCB.value = parseBool(DataArray["StrokeCB"]);
	
	FillCB = w.add("checkbox",undefined,"Fill");
	FillCB.value = parseBool(DataArray["FillCB"]);
	NewGroupCB = w.add("checkbox",undefined,"Group");
	NewGroupCB.value = parseBool(DataArray["NewGroupCB"]);
	
	myLabel = w.add ("statictext", undefined, "aeplug.ru");
	myLabel.alignment = 'right';
	if (w instanceof Window)
	{
		w.onClose = function(){CloseScript();}
		w.center();
		w.show();
	}
	else 
	{
		StrokeCB.onClick = function(){CloseScript();}
		FillCB.onClick = function(){CloseScript();}
		NewGroupCB.onClick = function(){CloseScript();}
		w.layout.layout(true);
	}
}

ReadDataFromIni();
buildGUI(this);

function CloseScript()
{
	SetData ("StrokeCB", StrokeCB.value);
	SetData ("FillCB", FillCB.value);
	SetData ("NewGroupCB", NewGroupCB.value);
	WriteDataToIni();
}

function Creation(t, name)
{
	var name = prompt("Name of the new shape", name);
	if (name)
	{
		app.beginUndoGroup("Add new shape layer");
		var curComp = app.project.activeItem;  
		var shapeLayer = curComp.layers.addShape();
		shapeLayer.name=name;
		if(NewGroupCB.value){
			var shapeGroup = shapeLayer.property("Contents").addProperty("ADBE Vector Group");
			shapeGroup.property("Material Options").enabled=false;
			}
		else{
			var shapeGroup = shapeLayer;
			}
		switch(t)
		{
			case 1:
				var myShape = shapeGroup.property("Contents").addProperty("ADBE Vector Shape - Ellipse"); 
				myShape.property("ADBE Vector Ellipse Size").setValue([500,500]);
				myShape.selected = true;
				break;
			case 2:
				var myShape = shapeGroup.property("Contents").addProperty("ADBE Vector Shape - Rect"); 
				myShape.property("ADBE Vector Rect Size").setValue([500,500]);
				myShape.selected = true;
				break;
			case 3:
				var myShape = shapeGroup.property("Contents").addProperty("ADBE Vector Shape - Group"); 
				myShape.selected = true;
				break;
		}
		if(StrokeCB.value){
			var stroke = shapeGroup.property("Contents").addProperty("ADBE Vector Graphic - Stroke");
			stroke.selected = true;
			}
		if(FillCB.value){
			var fill = shapeGroup.property("Contents").addProperty("ADBE Vector Graphic - Fill");
			fill.selected = true;
			}
		app.endUndoGroup();
	}
}

function SetData(str, value){
	if(DataArray[str]!=value.toString()){
		DataArray[str]=value;
		DataChanged = true;
	}
}

function ReadDataFromIni(){
	if (FileIni.exists) {
		PrintMessage("Чтени из файла "+FileIni.name);
		FileIni.open("r");
		while (!FileIni.eof) {
			temparr = FileIni.readln().split('=');
			if (temparr[1] != null) 
				DataArray[temparr[0]] = temparr[1];
		}
		FileIni.close();
		DataChanged = false;
	}
}

function WriteDataToIni(){
	if (DataChanged) {
		PrintMessage("Запись в файл "+FileIni.name);
		FileIni.open("w");
		for (var x in DataArray) 
			FileIni.writeln(x, "=", DataArray[x]);
		FileIni.close();
	}
}

function PrintMessage(str){
//~	if ($.level) $.writeln(str);
//~ 	$.writeln(str);
//~ 	alert(str);
//~ 	writeLn(str);
	}

function parseBool(val) { return val === true || val === "true" }
